unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  Buttons, ExtCtrls, ComCtrls, StdCtrls, uplutocompofilelist, xineStream,
  IceVLCPlayer, MPlayerCtrl,xine,xineVideoPlugin,xineAudioPlugin,xineEngine;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    MPlayerControl1: TMPlayerControl;
    PageControl1: TPageControl;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    PLDirectoryListBox1: TPLDirectoryListBox;
    PLFileListBox1: TPLFileListBox;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Timer1: TTimer;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PLFileListBox1DblClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    XineStream:TxineStream;
    XineVideo:TxineVideoPlugin;
    XineAudio:TxineAudioPlugin;
    XineEngine:TxineEngine;

    IceVLCPlayer:TIceVLCPlayer;
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation


{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Panel5.Canvas.AutoRedraw:=True;
  Panel5.DoubleBuffered:=True;
  XineEngine:=TxineEngine.Create(Form1);

  XineVideo:=TxineVideoPlugin.Create(Panel5);
  XineVideo.vWidget:=Panel5;

  XineAudio:=TxineAudioPlugin.Create(Panel5);
  XineAudio.audioDriver:=adAlsa;

  XineStream:=TxineStream.Create(Panel5);

  XineEngine.audioPlugin:=XineAudio;
  XineEngine.videoPlugin:=XineVideo;
  XineEngine.xStream:=XineStream;

  IceVLCPlayer:=TIceVLCPlayer.Create(Form1);

  IceVLCPlayer:=TIceVLCPlayer.Create(Panel4);
  IceVLCPlayer.Parent:=Panel4;
  IceVLCPlayer.Left:=0;
  IceVLCPlayer.Top:=0;
  //IceVLCPlayer.Align:=alClient;

end;

procedure TForm1.PLFileListBox1DblClick(Sender: TObject);
var
  s:String;
begin
  s:=PLDirectoryListBox1.CurrDir+PLFileListBox1.Items[PLFileListBox1.ItemIndex];
  case PageControl1.ActivePageIndex of
    0:IceVLCPlayer.Play(s);
    1: begin
      MPlayerControl1.Stop;
      MPlayerControl1.Filename:=s;
      MPlayerControl1.Play;
      Timer1.Enabled:=True;
    end; // 1
    2: begin
      if (Assigned(xineEngine)) and (xineEngine.init) then begin
        xineEngine.Pause; xineEngine.Stop; xineEngine.Close;
      end
      else
        xineEngine.Initialize;

      if (upperCase(ExtractFileExt(s)) <> '.ASX') or (upperCase(ExtractFileExt(s)) <> '.AVI') then begin
        writeln(xineEngine.Open(s));
        sleep(200);
      end;
    end; // 2
  end; // case
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  case PageControl1.ActivePageIndex of
    1: begin
      if not MPlayerControl1.Playing then begin
        PLFileListBox1.ItemIndex:=PLFileListBox1.ItemIndex+1;
        PLFileListBox1.Invalidate;
        PLFileListBox1DblClick(Sender);
      end
   end
   else
     Timer1.Enabled:=False;
  end; // case
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
//  IceVLCPlayer.PlayTV('/dev/dvb/adapter0/frontend0',0,0);
  IceVLCPlayer.Play(Dateinamen);
end;

initialization
  {$I Unit1.lrs}

end.

