program VLD2;
{ VideoLAN libvcl.dll (0.8.6b) Interface for Delphi (c)2007 by Paul TOTH }

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

{$APPTYPE CONSOLE}
uses
 Windows,
 VLC_Control in 'VLC_Control.pas';

var
 vlc  :libvlc_instance;
 name :string;
 video:integer;
 input:libvlc_input;
 excpt:libvlc_exception;

procedure check(name:string);
begin
 if excpt.code<>0 then begin
  WriteLn(name);
  WriteLn('exc.code=',excpt.code);
  WriteLn('exc.message=',excpt.message);
  libvlc_exception_clear(excpt);
 end;
end;

procedure main;
var
 args:array[0..1] of pchar;
 b:boolean;
begin
 FillChar(excpt,SizeOf(excpt),0);
 input:=nil;
 WriteLn('main');
 args[0]:=pchar(VLD_LibPath); // Lie or libvlc.dll wont work :(
 args[1]:=nil;
 vlc:=libvlc_new(1,@args[0],excpt);
 try
  Check('libvlc_new');
  WriteLn('vlc=',cardinal(vlc));

  name:=utf8encode(name);
  video:=libvlc_playlist_add(vlc,pchar(name),'MyVideo',excpt);
  Check('libvlc_playlist_add');
  WriteLn('video=',video);

  writeln('Playlist count=',libvlc_playlist_items_count(vlc,excpt));
  Check('libvlc_playlist_items_count');

  libvlc_playlist_play(vlc,video,0,nil,excpt);
  Check('libvlc_playlist_play');

  b:=libvlc_playlist_isplaying(vlc,excpt);
  Check('libvlc_playlist_isplaying');

  if b then begin

   WriteLn('PRESS ENTER TO GO FULLSCREEN FOR 3 SECONDS');
   ReadLn;

   input:=libvlc_playlist_get_input(vlc,excpt);
   check('libvlc_playlist_get_input');
   WriteLn('input=',cardinal(input));

   libvlc_set_fullscreen(input,excpt);
   check('libvlc_set_fullscreen');

   b:=libvlc_get_fullscreen(input,excpt);
   check('libvlc_get_fullscreen');
   if b then begin
    sleep(3000);
    libvlc_toggle_fullscreen(input,excpt);
    check('libvlc_toggle_fullscreen');
   end;

   WriteLn('width=',libvlc_video_get_width(input,excpt));
   check('libvlc_video_get_width');
   WriteLn('height=',libvlc_video_get_height(input,excpt));
   check('libvlc_video_get_height');


   Write('PRESS ENTER to PAUSE');
   ReadLn;
   libvlc_playlist_pause(vlc,excpt);
   check('libvlc_playlist_pause');

   WriteLn('length = ',libvlc_input_get_length(input,excpt));
   check('libvlc_input_get_length');
   WriteLn('time = ',libvlc_input_get_time(input,excpt));
   check('libvlc_input_get_time');
   WriteLn('position = ',libvlc_input_get_position(input,excpt):0:3);
   check('libvlc_input_get_position');

  end;

  b:=libvlc_playlist_isplaying(vlc,excpt);
  check('libvlc_playlist_isplay');
  if b=False then begin
   Write('PRESS ENTER to RESUME');
   ReadLn;
   libvlc_playlist_pause(vlc,excpt);
   check('libvlc_playlist_pause');
  end;

  b:=libvlc_playlist_isplaying(vlc,excpt);
  check('libvlc_playlist_isplaying');
  if b then begin

   Write('PRESS ENTER to MUTE');
   ReadLn;
   libvlc_audio_set_mute(vlc,true,excpt);
   check('libvlc_audio_set_mute');
   b:=libvlc_audio_get_mute(vlc,excpt);
   check('libvlc_audio_get_mute');
   if b then begin
    Write('PRESS ENTER to UNMUTE');
    ReadLn;
    libvlc_audio_set_mute(vlc,false,excpt);
    check('libvlc_audio_set_mute');
   end;

   WriteLn('volume=',libvlc_audio_get_volume(vlc,excpt));
   Check('libvlc_audio_get_volume');

   Write('PRESS ENTER to STOP');
   ReadLn;
   libvlc_playlist_stop(vlc,excpt);
   Check('libvlc_playlist_stop');
  end;
 finally
  libvlc_destroy(vlc);
 end;
 WriteLn('Ready');
end;

begin
 name:=ParamStr(1);
 if name='' then begin
  WriteLn('give a video filename');
 end else begin
  case VLD_Startup of
   VLD_SUCCESS  : main();
   VLD_NOLIB    : WriteLn('VLC not found');
   VLD_NOTFOUND : WriteLn('API not found');
  end;
 end;
 ReadLn;
end.
